###########################
###### SIZE ###############
###########################

XSIZE=10.; YSIZE=5.5; PX=1.
size_label = ',002'
size_key = ',20'
size_tics = ',001'

###########################
####### NAMES #############
###########################

outName = sprintf("./figure_3.eps");
#title = 'Taglio a z=400 {/Symbol m}m della densità (distanza bunch 60 {/Symbol m}m)'
x_label = 'inter event time t_{w}'
#y_label = 'n_e(400{/Symbol m}m,r)/n_0'

set terminal postscript eps enhanced defaultplex \
   leveldefault color colortext \
   dashlength 1.0 linewidth 1.0 pointscale 1.0 butt noclip \
   nobackground \
   palfuncparam 2000,0.003 \
   size int(XSIZE*PX),int(YSIZE*PX) \
   "Helvetica" 20  fontscale 1.0
set lmargin 7.5
set bmargin 3.5
set encoding iso_8859_1
set out outName



#########################################
####### functions and plots #############
######################################## 

g(x) = 0.000015/x**(1.65)

f(x)=a/x**b
b= 0.35
a = 0.0082

### Start multiplot (2x2 layout)
set multiplot layout 1,2 rowsfirst

# --- GRAPH a
#set label 1 'a' at graph 0.06,0.95 font 'Helvetica, 20'
set key vert top right font "Helvetica, 30"
set log
set xrange [10**(-3):]
set format x "10^{%+02T}"
set format y "10^{%+02T}" 
set xla '{ inter event time {t_{w}} }' font 'Helvetica, 30'
plot 'k_interevent.dat' every 3 u (exp($1)):($2*exp(-$1)) w boxes lw 3 lc rgb 'red' t'P[ t_{w}]', g(x) w l dt 1 lw 3 lc rgb 'black' t'{slope = 1.65}'

# --- GRAPH b
#set label 1 'b' at graph 0.06,0.95 font 'Helvetica, 20'
set log
unset xrange
set xrange [10**(-7):1]
set format x "10^{%+02T}"
set format y "10^{%+02T}"
set xla '{ size S }' font 'Helvetica, 30'
plot 'k_size.dat' every 3 u (exp($1)):($2*exp(-$1)) w boxes lw 3 lc rgb 'red' t'{P[S]}', f(x) w l dt 1 lw 3 lc rgb 'black'  t'{slope = 0.35}'

unset multiplot
### End multiplot
#
