PROGRAM main

  !dichiarazione variabili
  implicit none
  integer :: i, j, k, n_step, n_iter, ns, n_c, i2, tau !quest'ultimo è un contatore che mi serve  
  complex*16, DIMENSION (40) :: u   !velocità, forcing 
  real*8 :: A, eta, delta, ns_0, dt, time, e_size, e_sc_old, e_tot, e_sc, e_diss, k_in, l2, i_e, dedt, up   !Parametro forcing, viscosita, delta, k_0, intervallo temporale, tempo, energia dissipata calcolata, energia calcolata, energia data dal prodotto scalare, energia dissipata 
  COMMON /viscosita/eta 
  COMMON /parametro/delta
  COMMON /intervallo/dt
  COMMON /k_0/ns_0
  COMMON /shell/ns
  real*8, dimension (40) :: d, n_shell ! dissipazione, numero shell
  real*8 :: st_u(8,40)
  !real*8 :: st_e(8,1000)
  COMMON /struct/st_u
  !COMMON /struct/st_e
  COMMON /nshell/n_shell
  !COMMON /dissip/d   !controlla se conviene!

  !inizializzazione variabili
  A = 0.001
  eta = 10.**(-(9.))
  delta = 0.4
  ns = 40
  dt = 10.**(-(6.))
  ns_0 = 2.
  n_iter = 20000000
  n_step = 100
  time = 0.
  e_sc_old = 0.
  e_tot = 0.
  n_c = 0
  l2 = log(ns_0)
  i2 = 0
  e_size = 0
  i_e = 0
  up = 0

  !APRO UN FILE DOVE INSERISCO I PARAMETRI DELLA SIMULAZIONE
  OPEN(25, FILE= 'parameters.txt')
  write(25,*) 'Parameters:'
  write(25,*) 'nr shell = ', ns
  write(25,*) 'viscosity =', eta
  write(25,*) 'time interval =', dt
  write(25,*) 'iterations =', n_iter

  !APRO I FILE SU CUI RACCOGLIERÒ I DATI DELLA SIMULAZIONE
  OPEN (23, FILE= 'tau.dat')
  !OPEN(13,FILE= 'iter_energy_ediss_diff.dat') 
  OPEN (40, FILE= 'avalanche.dat')
  !OPEN (60, FILE= fileplace//'durata.dat')
  OPEN (8, FILE='condizioni_iniziali.dat')
  CALL dissipazione(d)

  do i=1, ns
    u(i)=0.01*n_shell(i)**(-0.3333)
  end do

  !do i=1, ns  
  !  READ(8, *) u(i)
  !end do
  !CLOSE(8)
  CALL dissipazione(d)
  do i = 1, n_iter
    
    !print*, i
    do j = 0, n_step
      CALL timestep(u)
      time = time + dt        
    end do
    n_c= n_c + 1
    CALL scalar(u,u,e_sc)
    CALL en_diss(u,e_diss)
    !CALCOLO DELLE FUNZIONI DI STRUTTURA
   ! CALL structure(u)
   ! OPEN (23, FILE='structure.dat')
   ! do k=2, ns-3
   !   k_in = log(n_shell(k))/l2
   !   write(23,*) k_in, log(st_u(3,k)/n_c)/l2, log(st_u(4,k)/n_c)/l2,  log(st_u(6,k)/n_c)/l2  
   ! end do
   ! CLOSE(23)
   ! WRITE(13,*) i, e_sc, eta*e_diss, e_sc-up
    
    dedt = e_sc - up !4*A - eta*e_diss
    if (dedt < 0) then
      e_size = e_size + (-1*dedt)
      write(23, *) i_e
      i_e = 0
    else
      i_e = i_e + 1
      write(40, *) e_size
      e_size = 0
    end if 
    up = e_sc
  end do

  OPEN (8, FILE='condizioni_iniziali_new.dat')
  do i=1, ns
    write(8,*) u(i)
  end do

END PROGRAM main

!--SUBROUTINES PER IL CALCOLO DELL'ENERGIA DISSIPATA  

!SUBROUTINE 1a: CALCOLO DELLA DISSIPAZIONE
SUBROUTINE dissipazione(d)
  real*8 :: ns_0, eta, dt
  integer :: i, ns
  real*8, dimension (40) :: d, n_shell
  COMMON /nshell/n_shell
  COMMON /viscosita/eta
  COMMON /intervallo/dt
  COMMON /k_0/ns_0
  COMMON /shell/ns
  !COMMON /dissip/d

  do i=1, ns
    n_shell(i) = ns_0**i
    d(i) = exp(-1*dt*eta*n_shell(i)*n_shell(i))
  end do

  return

END SUBROUTINE dissipazione


!SUBROUTINE 1a: CALCOLO DELLA DISSIPAZIONE
SUBROUTINE diss(u, up)
  real*8 :: ns_0
  integer :: i, ns
  real*8, dimension (40) :: d
  complex*16, dimension (40) :: u, up
  COMMON /k_0/ns_0
  COMMON /shell/ns
  !COMMON /dissip/d

  CALL dissipazione(d)
  do i=1, ns
    u(i) = d(i)*up(i)
  end do

  return

END SUBROUTINE diss


!SUBROUTINE 2: ADVECTION TERM
SUBROUTINE advection(u, t, phi)         !nota che stai SOLO descrivendo un procedimento, le variabili sono mute
  complex*16, DIMENSION (40) :: u, t, phi
  complex*16 :: b1, b2, b3  
  complex*16 :: img
  real*8, DIMENSION (40) :: n_shell
  COMMON /nshell/n_shell
  !COMMON /dissip/d
  integer :: ns
  real*8 :: b, delta
  COMMON /parametro/delta
  COMMON /shell/ns

  img = (0.,1.)
  ns = 40
  b = - delta
  do i=3, ns - 2
    b1 = n_shell(i)*u(i+2)*conjg(t(i+1))     
    b2 = n_shell(i-1)*b*u(i+1)*conjg(t(i-1))   
    b3 = n_shell(i-2)*(1+b)*u(i-1)*t(i-2)        
    phi(i) = img*(b1+b2+b3)
  end do
  i = 1
  b1 = n_shell(i)*u(i+2)*conjg(t(i+1))
  phi(i) = img*(b1)
  i = 2
  b1 = n_shell(i)*u(i+2)*conjg(t(i+1))
  b2 = n_shell(i-1)*(b)*u(i+1)*conjg(t(i-1))
  phi(i) = img*(b1+b2)
  i = ns - 1
  b2 = n_shell(i-1)*(b)*u(i+1)*conjg(t(i-1))
  b3 = n_shell(i-2)*(1+b)*u(i-1)*t(i-2)
  phi(i)=img*(b2+b3)
  i = ns
  b3 = n_shell(i-2)*(1+b)*u(i-1)*t(i-2)
  phi(i)=img*(b3)

  return

END SUBROUTINE advection

!SUBROUTINE 3: FORCING_1
SUBROUTINE force(u, fu)
  complex*16, DIMENSION (40) :: u, fu 
  complex*16 :: img      
  img = (0.,1.)

  CALL advection(u,u,fu)

END SUBROUTINE force

!SUBROUTINE 4: FORCING_2
SUBROUTINE forcing(u,fu)
  complex*16, DIMENSION (40) :: u, fu 
  complex*16 :: img      
  integer :: i
  real*8, dimension (40) :: n_shell
  COMMON /nshell/n_shell
  !COMMON /dissip/d

  img = (0.,1.)

  CALL force(u,fu) 
  do i=1, 2
    fu(i) = fu(i) + 0.001*(1. - img)/conjg(u(i))      !A=0.001
  end do

  return

END SUBROUTINE forcing

!SUBROUTINE 5: TIMESTEP
SUBROUTINE timestep(u)
  integer :: i, j, step, ns
  complex*16, DIMENSION (40) :: u, up, fu, fup
  complex*16 :: img 
  real*8 :: eta, dt   
  COMMON /viscosita/eta
  real*8, dimension (40) :: n_shell
  COMMON /nshell/n_shell
  COMMON /intervallo/dt
  COMMON /shell/ns
  !COMMON /dissip/d

  img=(0.,1.)

  CALL forcing(u,fu)
  do i=1, ns
    up(i) = u(i) + dt*fu(i)
  end do
  do step=1,2
    CALL forcing(up, fup)
    do j=1, ns
      up(j) = u(j) + 0.5*dt*(fu(j)+fup(j))
    end do
  end do

  CALL diss(u,up)
  return

END SUBROUTINE timestep

!SUBROUTINE 6: PRODOTTO SCALARE
SUBROUTINE scalar(u,w,prod)
  complex*16, DIMENSION (40) :: u, w
  real*8 :: prod
  integer :: i, ns
  COMMON /shell/ns

  prod = 0.
  do i=1, ns
    prod = prod + u(i)*conjg(w(i)) + w(i)*conjg(u(i))
  end do

  return

END SUBROUTINE scalar

!SUBROUTINE 7: ENERGIA DISSIPATA
SUBROUTINE en_diss(u,e_diss)
  complex*16, DIMENSION (40) :: u
  real*8 :: e_diss
  integer :: i, ns
  real*8, dimension (40) :: n_shell
  COMMON /nshell/n_shell
  COMMON /shell/ns      

  e_diss = 0.

  do i=1, ns
    e_diss = e_diss + n_shell(i)*n_shell(i)*real(u(i)*conjg(u(i)))
  end do

  return

END SUBROUTINE en_diss


!--SUBROUTINES PER IL CALCOLO DELLE FUNZIONI DI STRUTTURA

!SUBROUTINE 8: INIZIALIZZAZIONE FUNZIONI DI STRUTTURA
SUBROUTINE struct_in
  integer :: i, j, ns
  real*8, dimension (40) :: n_shell, d
  real*8 :: st_u(8,40)
  !real*8 :: st_e(8,1000)

  COMMON /struct/st_u
  !COMMON /struct/st_e
  COMMON /nshell/n_shell
  COMMON /shell/ns

  CALL  dissipazione(d)
  do i=1, ns
    do j=1, 8
      st_u(j,i)=0
    end do
  end do

  !do i=1, 1000
  ! do j=1, 8
  !  st_e(j,i)=0
  ! end do
  !end do 

  return

END SUBROUTINE

!SUBROUTINE 9: CALCOLO FUNZIONI DI STRUTTURA
SUBROUTINE structure(u)
  integer :: i, j, ns
  real*8, dimension (40) :: n_shell
  real*8 :: st_u(8,40)
  !real*8 :: st_e(8,1000)
  complex*16, DIMENSION (40) :: u
  complex*16 :: img 
  real*8 :: res   
  COMMON /struct/st_u
  !COMMON /struct/st_e
  COMMON /nshell/n_shell
  COMMON /shell/ns
  img = (0., 1.)
  do i=2, ns-3
    res = abs(dreal(img*u(i+1)*conjg(u(i-1))*conjg(u(i))))
    res = res**(1./3.)
    do j=1, 8 
      st_u(j,i) = st_u(j,i) + res**j
    end do
  end do

  return 

END SUBROUTINE 





